/** fichier libcom.c **/

/*****************************************************************/
/** Ce fichier contient des fonctions utilisees par le serveur  **/
/** SMTP   et concernant les sockets.                           **/
/*****************************************************************/

/**** Fichiers d'inclusion ****/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stddef.h>
#include <fcntl.h>
#include <errno.h>
#include <netdb.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <dirent.h>
#include <resolv.h>
#include "libcom.h"


/**** Variables globales *****/
extern  int s;
struct sockaddr_in adresse;
socklen_t taille=sizeof adresse;
char *service="4444"; // port de mon serveur

int relay_or_not= 0;
int debut_message=0;
char from [1024];
char subject[1024];
char *filename="temp_message.txt";
char to [1024];
char mailServer[1024];
char *mail="";
char* portNum="25";
FILE *fd_status=NULL;
FILE *fd_message = NULL;
FILE *fd_tampon= NULL;

char racine[100] ; // chemin du fichier de stockage des messages (aprés concaténation)
char racine2[100] ; // chemin du fichier .status (aprés concaténation)
int socket_publique=0; // si 0: socket locale; si 1: socket publique




/** Constantes **/
#define MAX_LIGNE 2048
#define N 4096

/**** Fonctions de gestion des sockets ****/


char *resolv_addr(char *domaine) // avec la fonction système res_search
{
	u_char nsbuf[N];
	char dispbuf[N];
	ns_msg msg;
	ns_rr rr;
	int i, l;
	char * adresse;
	l = res_search(domaine, ns_c_in, ns_t_a, nsbuf, sizeof(nsbuf));
	ns_initparse(nsbuf, l, &msg);
	l = ns_msg_count(msg, ns_s_an);
	for (i = 0; i < 1; i++)
	{
		ns_parserr(&msg, ns_s_an, i, &rr);
		ns_sprintrr(&msg, &rr, NULL, NULL, dispbuf, sizeof(dispbuf));
		adresse = strtok (dispbuf," ");
		adresse = strtok (NULL," ");
		adresse = strtok (NULL," ");
		adresse = strtok (NULL," ");
		adresse = strtok (NULL," ");
	}
	return adresse;
}

static FILE *connServDist(const char *hostname, const char *port) {
	FILE *f = NULL;
	int s;

	struct addrinfo precisions_adresse,*resultat_adresse,*origine_adresse;


	memset(&precisions_adresse,0,sizeof precisions_adresse);
	precisions_adresse.ai_family=AF_INET;
	precisions_adresse.ai_socktype=SOCK_STREAM;
	precisions_adresse.ai_flags = 0;
	precisions_adresse.ai_protocol = 0; 
	printf("LE RESULTAT DE RES_SEARCH EST:%s\n",resolv_addr(mailServer));


	s=getaddrinfo(resolv_addr(mailServer),port,&precisions_adresse,&origine_adresse); // utilisation de res_search dans resolv_addr
	if (s != 0) {
		fprintf(stderr, "getaddrinfo(): failed: %s.\n", gai_strerror(s));
	}

	for (resultat_adresse = origine_adresse; resultat_adresse != NULL; resultat_adresse = resultat_adresse->ai_next) {
		/* socket creation */
		if ((s = socket(AF_INET, SOCK_STREAM, 0))== -1) {
			perror("socket() failed: ");
			continue; 
		}

		if (connect(s, resultat_adresse->ai_addr, resultat_adresse->ai_addrlen) != -1) {
			break; 
		}
		else {
			perror("connect(): ");
		}
		close(s); /* err. ign. */
	}

	freeaddrinfo(origine_adresse);

	if (resultat_adresse == NULL) {
		fprintf(stderr, "Could not connect.\n");
	}
	else {

		if (!(f = fdopen(s, "r+"))) {
			perror("fdopen() failed: ");
		}
	}

	return f;
}

int relayMail(char* from, char* to, char* subject, char* filename, char* mailServer, char* portNum) 
{


	FILE *f;
	if ((f = connServDist(mailServer, portNum))) {
		int cmd;
		for(cmd = 1; cmd < 7; cmd++) 
		{
			char buffer[1024];
			fgets(buffer, sizeof(buffer), f);
			puts(buffer);
			if(cmd == 1) {
				fprintf(f, "HELO [127.0.0.1]\r\n");
			}
			else if(cmd == 2) {
				fprintf(f,"MAIL FROM: <%s>\r\n", from);
			}
			else if (cmd == 3){
				fprintf(f,"RCPT TO: <%s>\r\n", to);
			}
			else if (cmd == 4){
				fprintf(f,"DATA\r\n");
			}
			else if (cmd == 5){
				char* message;
				FILE * messageFile = fopen(filename, "r");
				fseek(messageFile, 0, SEEK_END);
				long length = ftell (messageFile);
				fseek(messageFile, 0, SEEK_SET);
				message = malloc(length);
				if (message) {
					fread (message, 1, length, messageFile);
				}
				fclose(messageFile);
				fprintf(f,"%s", subject);
				fprintf(f,"From: <%s>\r\n", from);
				fprintf(f,"To: %s\r\n\r\n",  to);
				fprintf(f,"%s\r\n\r\n.\r\n",  message);
				free(message);
				printf("%s", message);
			}
			else if (cmd == 6){
				fprintf(f,"QUIT\r\n");
			}
		}
		fclose(f);
	}
	return 0;
}



int count_files(char *repertoire) 
{
	int file_count = 0;
	DIR * dir;
	struct dirent * entry;

	dir = opendir(repertoire); 
	while ((entry = readdir(dir)) != NULL) {
		if (entry->d_type == DT_REG) { 
			file_count++;
		}
	}
	closedir(dir);
	return file_count;
}

int find_exped(char *fileName,char *strSearch) 
{
	FILE *fd;
	char c;
	int found=0;
	int pos=0;
	int length;
	fd = fopen(fileName,"r");
	if( fd == NULL )
		return 0;
	length=strlen(strSearch);
	while( fread(&c,1,1,fd)>0 && !found ) {
		if( c==strSearch[pos] ) {
			pos++;
		} else {
			if(pos!=0) {
				fseek(fd,-pos,SEEK_CUR);
				pos=0;
			}
		}
		found = (pos==length);
	}
	fclose(fd);
	return found;
}

void commandeHELO(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);	

}

void commandeMAIL(char *buffer, int s)
{

	char buffer_sortie[1024];
	char addr_expediteur[256+11];
	char user[64+5];
	char domain[64+5];
	char *acc_ouvr,*acc_ferm,*dom=domain;
	int portee;
	memset(addr_expediteur,0,231);
	acc_ouvr=strchr(buffer,'<');
	acc_ferm=strchr(buffer,'>');
	acc_ouvr++;
	portee=acc_ferm-acc_ouvr;
	strncpy(addr_expediteur,acc_ouvr,portee);
	dom=strchr(addr_expediteur,'@');
	dom=dom+1;
	memset(user,0,sizeof(user));
	strncpy(user,addr_expediteur,strlen(addr_expediteur)-strlen(dom)-1);		
	//printf("MAIL [%s] expediteur[%s] domain [%s]\n",addr_expediteur,user,dom);
	//printf("Expediteur %s\r\n",addr_expediteur);
	if(strncmp(dom,"localhost",9)==0)
	{
		sprintf(from, "%s@testmail.com",user);// car le serveur polytech n'accepte ni les adresse sans extension ni localhost
		//printf("the magnifiaayk from est: %s",from);
	}
	else
	{
		sprintf(from, "%s",user);
	}
	char file_users[]="../Messages/Users.txt";
	FILE * fd_users = fopen (file_users,"r");
	fclose(fd_users);
	int nb_files=0;
	char expediteur[100];
	sprintf(expediteur, "%s", addr_expediteur);
	char nb_messages[100];
	sprintf(nb_messages,"%i", nb_files );
	char sl[2]="/";
	sprintf(sl, "/");
	char extension[10];
	sprintf(extension, ".txt");
	sprintf(racine, "../Messages/Sent/");
	if(find_exped(file_users, addr_expediteur)>=1 && (socket_publique ==0)) // si l'utilisater existe
	{
		strcat(expediteur, sl);
		strcat(racine,expediteur);
		mkdir(racine,0777);// création du répertoire de l'utilisateur (même s'il y'a déja un répertoire)
		int a= count_files(racine);
		//printf("le nombre magique est : %d", a);
		sprintf(nb_messages,"%i", (a/2)+1 );
		strcat(nb_messages,extension);
		strcat(racine,nb_messages);
		//printf("La concaténation donne %s\n", racine);
		fd_message = fopen (racine,"a+");
		//strcat(racine,"status");
		strncpy(racine2,racine,strlen(racine)-3);
		strcat(racine2,"status");
		fd_status = fopen (racine2,"w");
		fprintf (fd_status,"ABORTED");
		fclose(fd_status);
		//printf("le descripteur de fichier est : %s", fd_message);
		sprintf(buffer_sortie, "250 OK expediteur connu\r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);
		printf("message du serveur:  %s", buffer_sortie);
	}
	else if (socket_publique ==0)
	{
		sprintf(buffer_sortie, "550 No Such User Here\r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);	
		printf("message du serveur:  %s", buffer_sortie);
	}
	if(socket_publique ==1) // si l'utilisater existe
	{
		strcat(expediteur, sl);
		strcat(racine,expediteur);
		mkdir(racine,0777);// création du répertoire de l'utilisateur (même s'il y'a déja un répertoire)
		int a= count_files(racine);
		//printf("le nombre magique est : %d", a);
		sprintf(nb_messages,"%i", (a/2)+1 );
		strcat(nb_messages,extension);
		strcat(racine,nb_messages);
		//printf("La concaténation donne %s\n", racine);
		fd_message = fopen (racine,"a+");
		//strcat(racine,"status");
		strncpy(racine2,racine,strlen(racine)-3);
		strcat(racine2,"status");
		fd_status = fopen (racine2,"w");
		fprintf (fd_status,"ABORTED");
		fclose(fd_status);
		//printf("le descripteur de fichier est : %s", fd_message);
		sprintf(buffer_sortie, "250 OK \r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);
		printf("message du serveur:  %s", buffer_sortie);
	}

}

int commandeRCPT(char *buffer, int s)
{
	char buffer_sortie[1024];
	//sprintf(buffer_sortie, "250 OK recipients memorises\r\n");
	//send(s, buffer_sortie, strlen(buffer_sortie), 0);
	//int relay_or_not=0;
	char addr[256+11];
	char user[64+5];
	char domain[64+5];
	char *acc_ouvr,*acc_ferm,*dom=domain;
	int portee;
	//printf("\nreceived RCPT\n");
	memset(addr,0,231);
	acc_ouvr=strchr(buffer,'<');
	acc_ferm=strchr(buffer,'>');
	acc_ouvr++;
	portee=acc_ferm-acc_ouvr;
	strncpy(addr,acc_ouvr,portee);
	dom=strchr(addr,'@');
	dom=dom+1;
	memset(user,0,sizeof(user));
	strncpy(user,addr,strlen(addr)-strlen(dom)-1);
	//printf("RCPT [%s] user [%s] domain [%s]\n",addr,user,dom);
	sprintf(to, "%s",addr);
	if  (socket_publique ==0)
	{
		if(strncmp(dom,"polytech-lille",14)==0)
		{
			sprintf(mailServer, "mail.polytech-lille.fr");
		}
		else if(strncmp(dom,"ifsttar",7)==0)
		{
			sprintf(mailServer, "mail.ifsttar.fr");
		}
		else
		{
			sprintf(mailServer, "smtp.%s",dom);
		}

		if(strncmp(dom,"localhost",9)==0)
		{
			sprintf(buffer_sortie, "250 OK user local\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);
		}
		else
		{
			sprintf(buffer_sortie, "251  User not local, RELAY\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);		
			int relay_or_not=1;
			//printf("relay_or_not= %d\n", relay_or_not);
			return relay_or_not;
		}
		//printf("relay_or_not= %d\n", relay_or_not);
	}
	else // si on est dans la socket liée à internet
	{
		if(strncmp(dom,"localhost",9)==0)
		{
			sprintf(buffer_sortie, "250 OK user local\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);
		}
		else
		{
			sprintf(buffer_sortie, "590 Unavailable mail box\r\n");
			send(s, buffer_sortie, strlen(buffer_sortie), 0);
			printf("message du serveur:  %s", buffer_sortie);
		}
	}
	return 0;
}

void commandeDATA(char *buffer,  int s)
{
	char buffer_sortie[1024];	
	//printf("tout est ok jusque la");
	//printf("%s", fd_message);                                 
	sprintf(buffer_sortie, "354 Continue, envoyez les donnees\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
}

void commande_traiter_DATA(char *buffer,  int s)
{
	if(debut_message==1 )
	{
		fprintf (fd_tampon,"%s",buffer);
	}
	//printf("POSITION DANS MESSAGE: %d", debut_message);
	if(strncmp(buffer,"Subject: ",9)==0)
	{
		sprintf(subject, "%s",buffer);
		//fprintf (fd_message,"%s",buffer);
	}
	if(strncmp(buffer,"\r\n",2)==0 )
	{
		fprintf (fd_message,"\r\n");
		if(debut_message==0)
		{
			debut_message=1;
		}
	}
	else
	{
		fprintf (fd_message,"%s",buffer);
	}
}

void commande_fin_DATA(char *buffer,  int s)
{
	char buffer_sortie[1024];	  
	/*
	 *	   if ((lockf(fd_message, F_LOCK, 0)) == -1) 
	 *	   {
	 *	   perror("lockf()");
	 *	   exit(EXIT_FAILURE);
	 } 
	 */
	sprintf(buffer_sortie, "250 OK Toutes les données sont recues\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
	/*
	 *	   if ((lockf(fd_message, F_ULOCK, 0)) == -1) 
	 *	   {
	 *	   perror("u-lockf()");
	 *	   exit(EXIT_FAILURE);
	 }
	 */
	fclose(fd_message);
	fclose(fd_tampon);
}

void commandeQUIT(char *buffer,  int s, int relay_or_not)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "221 OK on se deconnecte\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	//printf("la fin est: %d\n", relay_or_not);
	printf("message du serveur:  %s", buffer_sortie);
	//close(s);
	//printf("Client déconnecté");
	if(relay_or_not == 1)
	{
		//printf("LE DESTINATAIRE EST %s",to);
		fd_status = fopen (racine2,"w");
		fprintf (fd_status,"BEING TRANSFERED TO HOST MACHINE");
		fclose(fd_status);
		relayMail(from, to, subject, filename, mailServer, portNum);
		fd_status = fopen (racine2,"w");
		fprintf (fd_status,"TRANSFERED TO HOST MACHINE");
		fclose(fd_status);
	}
	else 
	{
		fd_status = fopen (racine2,"w");
		fprintf (fd_status,"ABORTED");
		fclose(fd_status);
	}
	//fclose(fd_status);
}


void commandeNOOP(char *buffer, int s)
{
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "220  Service Ready\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);
}

void commandeRSET(char *buffer, int s)
{
	// FAIRE DES MEMSET SUR LES VARIABLES				
	char buffer_sortie[1024];
	sprintf(buffer_sortie, "250 OK on reset tout\r\n");
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	printf("message du serveur:  %s", buffer_sortie);

}



void redirection_Commandes(char *buffer, int s)
{
	int commande_digit=4; // CONSTANTE
	char buffer_sortie[1024];
	//int relay_or_not=0;
	//int relay_or_not= 19;
	if(strncmp(buffer,"EHLO",commande_digit)==0 || strncmp(buffer,"HELO",commande_digit)==0)
		commandeHELO(buffer,s);
	else if(strncmp(buffer,"MAIL",commande_digit)==0)
		commandeMAIL(buffer,s);
	else if(strncmp(buffer,"RCPT",commande_digit)==0)
	{
		relay_or_not=commandeRCPT(buffer,s);
	}
	else if(strncmp(buffer,"RSET",commande_digit)==0)
		commandeNOOP(buffer,s);
	else if(strncmp(buffer,"QUIT",commande_digit)==0)
		commandeQUIT(buffer,s,relay_or_not);
	else 
	{
		sprintf(buffer_sortie, "502 La commande n'est pas implementee\r\n");
		send(s, buffer_sortie, strlen(buffer_sortie), 0);
		printf("message du serveur:  %s", buffer_sortie);
	};
}


void gestionClientTCP(int s)
{
	/* Obtient une structure de fichier */
	FILE *dialogue=fdopen(s,"a+"); // acces à un fichier en mode lecture et écriture et append (ne pas écraser)
	if(dialogue==NULL){ perror("gestionClientTCP.fdopen"); exit(EXIT_FAILURE); }
	fd_tampon = fopen ("temp_message.txt","w+");
	int dans_message=0;
	char buffer[1024], buffer_sortie[1024];
	sprintf(buffer_sortie, "220 localhost SMTP server \r\n");
	printf("%s", buffer_sortie);
	send(s, buffer_sortie, strlen(buffer_sortie), 0);
	while(fgets(buffer,MAX_LIGNE,dialogue)!=NULL)
	{
		printf("message du client: %s", buffer);
		//scanf("%s",&message_serveur);
		//fprintf(dialogue,"message du serveur:  %s",ligne);
		if(dans_message==0)
		{
			if(strncmp(buffer,"DATA",4)==0)
			{
				commandeDATA(buffer,s);
				dans_message=1;
			}
			else
				redirection_Commandes(buffer,s);
		}
		if(dans_message==1)
		{
			if(strncmp(buffer,".\r\n",3)==0)
			{
				commande_fin_DATA(buffer,s);
				dans_message=0;
				debut_message=0;
			}
			else
			{
				commande_traiter_DATA(buffer,s);
			}
		}
	}
	/* Termine la connexion */
	fclose(dialogue);
	printf("client déconnecté\n");
}


int multi_gestionClientTCP(int s)
{
	lanceThread(gestionClientTCP,(int) s,0);
	return 0;
}





int initialisationServeurSocket_locale(void){
	struct addrinfo precisions,*resultat,*origine; // liste chainée pour trouver des adresses
	int statut; 
	int s; // descripteur de fichier pour la socket serveur TCP
	int connexions=12; // Mettre en consrante 

	/* Construction de la structure adresse */
	memset(&precisions,0,sizeof precisions);
	precisions.ai_family=PF_INET6; // aucune précision, donc prend aussi en compte les clients IPv4
	precisions.ai_socktype=SOCK_STREAM; // Type de socket: TCP (mode flux, connecté) => SOCK_STREAM 
	precisions.ai_flags=AI_PASSIVE; // On veut un serveur (ne fait qu'écouter) => AI_PASSIVE (AI_ACTIVE pour client)
	statut=getaddrinfo(NULL,service,&precisions,&origine);
	if(statut<0){ perror("initialisationServeur.getaddrinfo"); exit(EXIT_FAILURE); }
	struct addrinfo *p;
	for(p=origine,resultat=origine;p!=NULL;p=p->ai_next)
	{
		//if(p->ai_family==AF_INET6){ resultat=p; break; } // chercher des adresses jusqu'à IP v6 
	}  
	/* Creation d'une socket */
	s=socket(resultat->ai_family,resultat->ai_socktype,resultat->ai_protocol);
	if(s<0){ perror("initialisationServeur.socket"); exit(EXIT_FAILURE); }
	printf("Socket TCP crée avec succes\n"); 

	/* Options utiles */
	int vrai=1;
	// socket=s; niveau"reseau (sol_socket)"=; option= adresse reutilisable
	if(setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&vrai,sizeof(vrai))<0){
		perror("initialisationServeur.setsockopt (REUSEADDR)");
		exit(EXIT_FAILURE);
	}
	// socket=s; niveau"couche de transport (mode TCP)"=; option= pas de retard (delay) pour envoyer les messages
	if(setsockopt(s,IPPROTO_TCP,TCP_NODELAY,&vrai,sizeof(vrai))<0){
		perror("initialisationServeur.setsockopt (NODELAY)");
		exit(EXIT_FAILURE);
	}

	/* Specification de l'adresse de la socket */
	statut=bind(s,resultat->ai_addr,resultat->ai_addrlen);
	if(statut<0) return -1;
	printf("Socket TCP \"bindé\" avec succes\n"); 

	/* Liberation de la structure d'informations */
	freeaddrinfo(origine); // libérer la liste chainée

	/* Taille de la queue d'attente */
	statut=listen(s,connexions); // écoute sur la file d'attentes de taille=[connecions]
	printf("En attente de connexion avec les clients TCP\n");
	if(statut<0) return -1;

	return s;
}

int initialisationServeurSocket_publique(char *addr_machine){

	socket_publique=1;// condition sur les clients qui se connectent sur la socket publique
	struct addrinfo precisions,*resultat,*origine; // liste chainée pour trouver des adresses
	int statut; 
	int s; // descripteur de fichier pour la socket serveur TCP
	int connexions=12; // Mettre en consrante 

	/* Construction de la structure adresse */
	memset(&precisions,0,sizeof precisions);
	precisions.ai_family=PF_INET6; // aucune précision, donc prend aussi en compte les clients IPv4
	precisions.ai_socktype=SOCK_STREAM; // Type de socket: TCP (mode flux, connecté) => SOCK_STREAM 
	precisions.ai_flags=AI_PASSIVE; // On veut un serveur (ne fait qu'écouter) => AI_PASSIVE (AI_ACTIVE pour client)
	statut=getaddrinfo(NULL,service,&precisions,&origine);
	if(statut<0){ perror("initialisationServeur.getaddrinfo"); exit(EXIT_FAILURE); }
	struct addrinfo *p;
	for(p=origine,resultat=origine;p!=NULL;p=p->ai_next)
	{
		//if(p->ai_family==AF_INET6){ resultat=p; break; } // chercher des adresses jusqu'à IP v6 
	}  
	/* Creation d'une socket */
	s=socket(resultat->ai_family,resultat->ai_socktype,resultat->ai_protocol);
	if(s<0){ perror("initialisationServeur.socket"); exit(EXIT_FAILURE); }
	printf("Socket TCP crée avec succes\n"); 

	/* Options utiles */
	int vrai=1;
	// socket=s; niveau"reseau (sol_socket)"=; option= adresse reutilisable
	if(setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&vrai,sizeof(vrai))<0){
		perror("initialisationServeur.setsockopt (REUSEADDR)");
		exit(EXIT_FAILURE);
	}
	// socket=s; niveau"couche de transport (mode TCP)"=; option= pas de retard (delay) pour envoyer les messages
	if(setsockopt(s,IPPROTO_TCP,TCP_NODELAY,&vrai,sizeof(vrai))<0){
		perror("initialisationServeur.setsockopt (NODELAY)");
		exit(EXIT_FAILURE);
	}

	/* Specification de l'adresse de la socket */
	statut=bind(s,resultat->ai_addr,resultat->ai_addrlen);
	if(statut<0) return -1;
	printf("Socket TCP \"bindé\" avec succes\n"); 

	/* Liberation de la structure d'informations */
	freeaddrinfo(origine); // libérer la liste chainée

	/* Taille de la queue d'attente */
	statut=listen(s,connexions); // écoute sur la file d'attentes de taille=[connecions]
	printf("En attente de connexion avec les clients TCP\n");
	if(statut<0) return -1;

	return s;
}

int boucleServeurTCP(int s,int (*multigestionClientTCP)(int))
{
	int dialogue; // socket pour le dialogue entre serveur et clients
	while(1){
		/* Attente d'une connexion */
		if((dialogue=accept(s,(struct sockaddr *)&adresse,&taille))<0) return -1;
		printf("client connecté\n");
		memset (racine, 0, sizeof (racine));
		memset (racine2, 0, sizeof (racine2));

		/* Passage de la socket de dialogue a la fonction de traitement */
		if(multi_gestionClientTCP(dialogue)<0){ shutdown(s,SHUT_RDWR); return 0;}
	}
	return s;
}
